SystemOrganization addCategory: #'Tadp - Prueba - Tests'!
SystemOrganization addCategory: #'Tadp - Prueba'!
SystemOrganization addCategory: #'Tadp - Tp1'!
SystemOrganization addCategory: #'Tadp - Tp1 - Tests'!
SystemOrganization addCategory: #'Tadp - Tp1-Tests'!
SystemOrganization addCategory: #'Tadp - Tp1 '!
SystemOrganization addCategory: #'Tadp - Tp2'!
SystemOrganization addCategory: #'Tadp - Tp2 - Ejemplo'!

Trait named: #DiscoMagneticoConsumo
	uses: {}
	category: 'Tadp - Tp1'!

!DiscoMagneticoConsumo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 16:44'!
consumo
	^((self revoluciones * 50) / 10000)! !

Trait named: #PlacasAptasParaVideoJuegos
	uses: {}
	category: 'Tadp - Tp1'!

!PlacasAptasParaVideoJuegos methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:28'!
apta
	^true! !

!PlacasAptasParaVideoJuegos methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:28'!
noApta
	^false! !

!PlacasAptasParaVideoJuegos methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:01'!
pantallaApta
	^(self refresco > self entrada refresco)
	ifTrue: [self entrada refresco > 100] ifFalse: [self refresco > 100]! !

!PlacasAptasParaVideoJuegos methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:50'!
porCalculo
	^((self pixeles ln) / self consumo > 4)! !

Trait named: #PlacasConsumo
	uses: {}
	category: 'Tadp - Tp1'!

!PlacasConsumo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 15:47'!
consumo
	^(self pixeles > self definicionMonitor )
	ifTrue: [self consumo: self pixeles ] ifFalse:[self consumo: self definicionMonitor  ]! !

!PlacasConsumo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 15:47'!
consumo: valor
	^(valor * (1/100000))! !

!PlacasConsumo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:15'!
consumoReal
	^self consumo + (self cantCoolers * 0.5)! !

Trait named: #TecnologiaAnalogica
	uses: {}
	category: 'Tadp - Tp1'!

!TecnologiaAnalogica methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:50'!
definicionMaxima 
	^480! !

Trait named: #TecnologiaDigital
	uses: {}
	category: 'Tadp - Tp1'!

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:50'!
definicionMaxima
	^self ppp*(self tamao/2)! !

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:22'!
ppp
	^self requirement.! !

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:22'!
tamao
	^self requirement.! !

TestCase subclass: #Test
	instanceVariableNames: 'pantalla entrada computadora placa disco cable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1-Tests'!

!Test methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:42'!
setUp

	pantalla:= Lcd new.
	pantalla tamao: 20.
	pantalla ppp:100.
	pantalla monitor.
	
	entrada:= Vga new.
	pantalla entrada: entrada.
	
	cable := Cable new.
	cable definicion: 720.
	
	entrada cable: cable.
	
	computadora := Computadora new.
	placa := GPU new.
	placa pixeles: 100000.
	placa cantCoolers: 5.
	
	disco := DiscoMagnetico new.	
	disco revoluciones: 200.
	
	computadora placa: placa.
	computadora monitor: pantalla.
	computadora disco: disco.! !

!Test methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:41'!
testCompuAptaVideoJuegos
	
	self assert: computadora aptaVideoJuegos  equals:true.
! !

!Test methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:41'!
testCompuConsumo
	
	self assert: computadora consumo  equals:84.5.
! !

!Test methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:44'!
testConsumo
	
	self assert: pantalla consumoReal  equals: 80.72! !

!Test methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:41'!
testEntradaCable

	pantalla:= Crt new.
	cable:= Cable  new.
	entrada := Vga new.
	
	pantalla entrada: entrada.
	cable definicion: 1080.
	entrada cable: cable.
	
	self assert: pantalla definicionMaximaTotal  equals:480.
	
! !

!Test methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:44'!
testPantallaAptaVideoJuegos

	self assert: pantalla aptaParaVideoJuegos  equals:true.! !

!Test methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:44'!
testSePuedeConectar
	
	self assert: (pantalla sePuedeConectar: cable) equals:true.! !

Object subclass: #Automovil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp2 - Ejemplo'!

!Automovil methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 14:50'!
metodo1
	^1.! !

!Automovil methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 14:51'!
metodo2
		^2.! !

!Automovil methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 14:51'!
metodo3 
		^3.! !

Object subclass: #Cable
	instanceVariableNames: 'definicion refresco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Cable methodsFor: 'setters/getters' stamp: 'Christian 4/7/2013 18:53'!
definicion 
	^definicion ! !

!Cable methodsFor: 'setters/getters' stamp: 'EmilianoGomar 4/19/2013 01:24'!
definicion: cant
	^definicion := cant! !

!Cable methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:58'!
refrescoMaximo
	^refresco ! !

!Cable methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:58'!
refrescoMaximo:cant
	refresco:= cant! !

Object subclass: #CiertoMetodo
	instanceVariableNames: 'clase metodo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp2'!

!CiertoMetodo methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:45'!
clase
	^clase.! !

!CiertoMetodo methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:44'!
clase: unaClase
	clase := unaClase.! !

!CiertoMetodo methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:44'!
metodo
	^metodo.! !

!CiertoMetodo methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:44'!
metodo: unMetodo
	metodo := unMetodo.! !

Object subclass: #Computadora
	instanceVariableNames: 'placaVideo discoRigido monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:59'!
aptaVideoJuegos
	^(monitor aptaParaVideoJuegos & placaVideo aptaParaVideoJuegos )! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:23'!
consumo
	^(placaVideo consumoReal + discoRigido consumo + monitor consumo)! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 15:54'!
definicionMonitor
	^(monitor definicionMaximaTotal)! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/16/2013 23:38'!
disco: valor
	discoRigido := valor! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/17/2013 02:55'!
monitor: valor
	monitor := valor ! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 00:53'!
placa: valor
	placaVideo := valor.
	placaVideo compu: self! !

Object subclass: #DiscoMagnetico
	uses: DiscoMagneticoConsumo
	instanceVariableNames: 'revoluciones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

DiscoMagnetico class
	uses: DiscoMagneticoConsumo classTrait
	instanceVariableNames: ''!

!DiscoMagnetico methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:18'!
revoluciones 
	^revoluciones ! !

!DiscoMagnetico methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:18'!
revoluciones: valor
	revoluciones := valor ! !

Object subclass: #DiscoSolido
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!DiscoSolido methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:19'!
consumo 
	^consumo ! !

!DiscoSolido methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 05:19'!
consumo: valor 
	consumo := valor ! !

Object subclass: #Entrada
	instanceVariableNames: 'pantalla refresco cable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Entrada subclass: #Av
	uses: TecnologiaAnalogica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Av class
	uses: TecnologiaAnalogica classTrait
	instanceVariableNames: ''!

!Av methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:39'!
consumo
	^self consumoEnPorcentaje: 10! !

!Av methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 22:55'!
refresco
	^50! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 23:38'!
cable
	^cable! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 01:35'!
cable: nuevoCable
	cable:=nuevoCable .! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:46'!
consumo
	 ^0! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:37'!
consumoEnPorcentaje: porcentaje
	^pantalla consumo * porcentaje /100! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 23:38'!
definicionMaxima
	^cable definicion.! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 22:54'!
pantalla
	^pantalla ! !

!Entrada methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:30'!
pantalla: nuevaPantalla
	pantalla :=nuevaPantalla ! !

Entrada subclass: #Hdmi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Hdmi methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:39'!
consumo
	^self consumoEnPorcentaje: 20! !

!Hdmi methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 02:58'!
refresco
	^cable refrescoMaximo  ! !

!Hdmi methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 22:58'!
refresco: valor 
	refresco := valor! !

Entrada subclass: #Rf
	uses: TecnologiaAnalogica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Rf class
	uses: TecnologiaAnalogica classTrait
	instanceVariableNames: ''!

!Rf methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 22:55'!
refresco
	^50! !

Entrada subclass: #Vga
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Vga methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 23:38'!
consumo
	^0.001*cable definicion ! !

!Vga methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 00:13'!
pantalla
	^pantalla ! !

!Vga methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 22:56'!
refresco
	^120! !

Object subclass: #Pantalla
	uses: PlacasAptasParaVideoJuegos @ {#aptaParaVideoJuegos->#pantallaApta} - {#porCalculo. #apta. #noApta. #pantallaApta}
	instanceVariableNames: 'tamao refresco entrada cable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Pantalla class
	uses: PlacasAptasParaVideoJuegos classTrait
	instanceVariableNames: ''!

Pantalla subclass: #Crt
	uses: TecnologiaAnalogica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Crt class
	uses: TecnologiaAnalogica classTrait
	instanceVariableNames: ''!

!Crt methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:28'!
consumo
	^super consumo:5! !

Pantalla subclass: #Lcd
	uses: TecnologiaDigital
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Lcd class
	uses: TecnologiaDigital classTrait
	instanceVariableNames: ''!

!Lcd methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:28'!
consumo
	^super consumo:4! !

!Lcd methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:55'!
ppp
	^ppp! !

!Lcd methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:37'!
ppp: cant
	ppp:=cant! !

!Lcd methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 16:38'!
tamao
	^tamao.! !

Pantalla subclass: #Led
	uses: TecnologiaDigital
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Led class
	uses: TecnologiaDigital classTrait
	instanceVariableNames: ''!

!Led methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:28'!
consumo
	^super consumo:1! !

!Led methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:55'!
ppp
	^ppp! !

!Led methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:37'!
ppp: cant
	ppp:=cant! !

!Led methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:24'!
smartTv
	self refresco:135! !

!Led methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 16:43'!
tamao
	^tamao.! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:55'!
cable
	^cable! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:54'!
cable: nuevoCable
	cable:=nuevoCable .! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:26'!
consumo: cant
	^cant * tamao! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:34'!
consumoReal
	^self consumo + entrada consumo
	! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:58'!
definicionMaximaTotal
	(entrada definicionMaxima>self definicionMaxima)
	ifTrue: [^self definicionMaxima] ifFalse: [^entrada definicionMaxima]
	! !

!Pantalla methodsFor: 'setters/getters' stamp: 'EmilianoGomar 4/19/2013 05:00'!
entrada
	^entrada! !

!Pantalla methodsFor: 'setters/getters' stamp: 'EmilianoGomar 4/19/2013 01:16'!
entrada: nuevaEntrada
	entrada:=nuevaEntrada.
	entrada  pantalla:  self.
! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 12:03'!
monitor
	self refresco:120! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 12:03'!
refresco 
	^refresco ! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 12:03'!
refresco: cant
	refresco := cant
	! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 03:57'!
sePuedeConectar: unCable
	^(unCable definicion < self definicionMaxima) 
	ifTrue: [true] ifFalse: [false]! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:24'!
tamao
	^tamao! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:36'!
tamao: cant
	tamao:= cant! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 12:04'!
tv
	self refresco:90! !

Object subclass: #PlacaVideo
	instanceVariableNames: 'pixeles cantCoolers compu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

PlacaVideo subclass: #GPU
	uses: PlacasConsumo + PlacasAptasParaVideoJuegos @ {#aptaParaVideoJuegos->#apta} - {#porCalculo. #apta. #noApta. #pantallaApta}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

GPU class
	uses: PlacasConsumo classTrait + PlacasAptasParaVideoJuegos classTrait
	instanceVariableNames: ''!

!GPU methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 15:49'!
definicionMonitor 
	^compu definicionMonitor ! !

!GPU methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 15:45'!
pixeles
	^pixeles! !

!GPU methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:50'!
porCalculo
	^true! !

PlacaVideo subclass: #OnBoard
	uses: PlacasConsumo - {#consumo. #consumo:} + PlacasAptasParaVideoJuegos @ {#aptaParaVideoJuegos->#noApta} - {#porCalculo. #apta. #noApta. #pantallaApta}
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

OnBoard class
	uses: PlacasConsumo classTrait + PlacasAptasParaVideoJuegos classTrait
	instanceVariableNames: ''!

!OnBoard methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/17/2013 03:29'!
consumo
	^consumo! !

!OnBoard methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/17/2013 19:43'!
consumo: valor
	consumo := valor ! !

PlacaVideo subclass: #PlacaRegular
	uses: PlacasAptasParaVideoJuegos @ {#aptaParaVideoJuegos->#porCalculo} - {#porCalculo. #apta. #noApta. #pantallaApta} + PlacasConsumo - {#consumo. #consumo:}
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

PlacaRegular class
	uses: PlacasAptasParaVideoJuegos classTrait + PlacasConsumo classTrait
	instanceVariableNames: ''!

!PlacaRegular methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/17/2013 19:45'!
consumo
	^consumo ! !

!PlacaRegular methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/17/2013 19:45'!
consumo: valor
	consumo := valor ! !

!PlacaRegular methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 16:57'!
pixeles
	^pixeles ! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:16'!
cantCoolers 
	^cantCoolers ! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:16'!
cantCoolers: cant
	cantCoolers := cant ! !

!PlacaVideo methodsFor: 'setters/getters' stamp: 'EmilianoGomar 4/18/2013 00:34'!
compu: valor
	compu := valor ! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/19/2013 04:20'!
initialize 
	cantCoolers := 0.! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/17/2013 19:42'!
pixeles: valor
	pixeles := valor ! !

Object subclass: #TheInterceptor
	instanceVariableNames: 'ciertosMetodos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp2'!

!TheInterceptor methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:15'!
devolver: unMetodo en:unaClase
     ^Automovil selectors detect: [:unM | unM asString beginsWith: unMetodo] ifNone: [nil].! !

!TheInterceptor methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:57'!
ejecutarLosMetodos
	ciertosMetodos do:[:unMetodo | unMetodo clase new perform: (unMetodo metodo).]! !

!TheInterceptor methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:47'!
elegirUn: unMetodo deUna: unaClase
	| ciertoMetodo | 
	ciertoMetodo := CiertoMetodo new.
	
	ciertoMetodo metodo: (self devolver: unMetodo en: unaClase).
	(self = nil)
	ifTrue: [^'No existe ese metodo']
	ifFalse: [ciertoMetodo clase: unaClase.
			ciertosMetodos add: ciertoMetodo.] 
	! !

!TheInterceptor methodsFor: 'as yet unclassified' stamp: 'PatoDonald 5/4/2013 15:18'!
initialize
		ciertosMetodos := OrderedCollection new.! !
